/*
JSgui/ygwm-options.js
created jeu. sept.  8 06:53:52 CEST 2011 by whygee@f-cpu.org

Takes stuff out of ygwm.js to keep it modular.
*/

ygwm.changeWinTitle= function(f, value, unfiltered){
  // If called by a click, then f is the field that was changed.
  // If called by JS, f is the window and value is the new text.
  var w = f;
  if (typeof value!=='string'){
    w = ygwm.getParent(f);
    value=f.value;
  }
// Cleanup the value, escape a couple of characters
  if (!unfiltered) {
    value=value.replace(/&/g,'&amp;');
    value=value.replace(/</g,'&lt;');
  }
// modify the fields
  w.header_name.innerHTML = value;
  if (w.winlist_item_id)
    winlist.rename(w.winlist_item_id,value);
};

ygwm.changeTheme= function(target, theme) {
  var where=ygwm.getParent(target);
//  ygwm.add_new_window_style(theme);
  where.className=theme;
  if (where.winlist_item_id && YGCSS){
    if (YGCSS.ColorStyles[where.className])
      where.winlist_item_id.style.backgroundColor
        =YGCSS.ColorStyles[where.className].split(',')[4];
  }
};

ygwm.menuClick= function(){
  var w = ygwm.getParent(this);
  var a=w.menuButtonInside.style;

  // hide the contents, create and display the menu
  if (a.display=="none") {
    a.display=""; // show the inner dot so the button appears as a circle

    w.old_contents=w.contents_id.firstChild; // save and hide the contents
    w.contents_id.removeChild(w.old_contents);
    
    // instead, display the menu and options
    newmenu=document.createElement("DIV");
    w.contents_id.appendChild(newmenu);
    var html='<h2>Options</h2>'
      +'<p>Window title : '
      +'<input type="text" size="30" maxlength="250" name="wintitle" onchange="ygwm.changeWinTitle(this)" value="'+w.header_name.innerHTML+'"></p>';

if (YGCSS) {
      html+='Color theme :<br>';

    function createButton(i) {
//      ygwm.add_new_window_style(i);
      html+='<div class="'+i+'" style="position:static;float:left;cursor:pointer;margin:2px;"'
          + ' onclick="ygwm.changeTheme(this,\''+i+'\')"><div class="ygwm_header">'
      if (w.className==i)
        html+='<b>'+i+'</b>';
      else
        html+=i;
      html+='</div></div>';
    }
//    createButton("ygwm_div");
    for (var i in YGCSS.ColorStyles)
      createButton(i);
}

//    html+="</p>";

    newmenu.innerHTML=html;
  }
  // save the options, remove the menu and restore the original contents
  else {
    a.display="none"; // hide the dot => filled circle

    w.contents_id.removeChild(w.contents_id.firstChild);

    w.contents_id.appendChild(w.old_contents);
    w.old_contents=null;
  }
};
